#!/usr/bin/perl -w

package KartaKontaktniOsoby;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gnome2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;
use lib::Seznam;

my $MyUI;
my %MyMoney;
my $retcode="";
my $KartaKontaktniOsoby;
my $Locks;
my $in_init=0;

sub upravit {
    my ($self, $locked, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    $self->{'firma_id'}=0;
    $self->{'locked'}=$locked;
    if($where && !$locked) {
        $KartaKontaktniOsoby=new Table('a_AdresarO',%MyMoney);
        if(!$KartaKontaktniOsoby->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            return(0);
        };
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('a_AdresarF',"id='".$KartaKontaktniOsoby->get('firma_id')."'")) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

#
# Upravujeme zaznam, ktery neni v DB
#
sub upravit_novy {
    my ($self, $locked, $where, $Osoba, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    $self->{'firma_id'}=0;
    $self->{'locked'}=1;
    $KartaKontaktniOsoby=new Table('a_AdresarO',%MyMoney);
    $KartaKontaktniOsoby->set_data($Osoba->get_data);
    $self->{'novy_zaznam'}=1;
    my $retval=$self->run($dissable_ok, $where,0,%params);
    $self->{'novy_zaznam'}=0;
    return($retval);
};

sub kopirovat {
    my ($self, $locked, $where, %params) = @_;
    $Locks=0;
    $self->{'firma_id'}=0;
    $self->{'locked'}=$locked;
    %MyMoney=%params;
    my $dissable_ok=0;
    if(!$locked) {
        $KartaKontaktniOsoby=new Table('a_AdresarO',%MyMoney);
        if(!$KartaKontaktniOsoby->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            return(0);
        };
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('a_AdresarF',"id='".$KartaKontaktniOsoby->get('firma_id')."'")) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,1,%params));
};

sub pridat {
    my ($self,$locked,$firma_id, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    my $dissable_ok=0;
    $self->{'firma_id'}=$firma_id;
    $self->{'locked'}=$locked;
    if(!$locked) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('a_AdresarF',"id='".$firma_id."'")) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    #$Locks=new Locks(%MyMoney);
    #if(!$Locks->create_lock('a_AdresarO',$where,1)) {
    #    return(0);
    #};
    $KartaKontaktniOsoby=new Table('a_AdresarO',%MyMoney);
    if(!$KartaKontaktniOsoby->load($where,1)) {
        my $Dialog=new Dialog;
        $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
        return(0);
    };
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('a_AdresarF',"id='".$KartaKontaktniOsoby->get('firma_id')."'",1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    my $window=$class;
    $MyUI=$class;
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox256'};
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };
    if(!$MyUI->{'novy_zaznam'}) {
        $KartaKontaktniOsoby=new Table('a_AdresarO',%MyMoney);
        if($where) {
            if(!$KartaKontaktniOsoby->load($where,1)) {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
                if($Locks) {
                    $Locks->remove_lock;
                };
                return(0);
            };
        };
    };
    
    if($class->{'firma_id'}) {
        $KartaKontaktniOsoby->set('firma_id',$class->{'firma_id'});
    };
    $in_init=1;
    $KartaKontaktniOsoby->WriteToUI($window->FORM);
    $in_init=0;
    $MyUI->on_email_changed;
    
    $window->TOPLEVEL->set_title('Karta kontaktni osoby');
    $MyMoney{'MainCfg'}->window_open("KartaKontaktniOsoby",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaKontaktniOsoby",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KartaKontaktniOsoby_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaKontaktniOsoby",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $KartaKontaktniOsoby->ReadFromUI($MyUI->FORM);
    if(!$KartaKontaktniOsoby->get('prijmeni')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Prijmeni nemuze byt prazdne!","type"=>"error");
            return;        
    };
    if(!$MyUI->{'locked'}) {
        if($MyUI->{'where'}) {
            if(!$KartaKontaktniOsoby->update) {
                return;
            };
            
            #
            # pokud upravujeme majitele firmy, tak musime aktualizovat cely zaznam pro firmu
            #
            my $KartaAdresare=new Table('a_AdresarF',%MyMoney);
            $KartaAdresare->load("id='".$KartaKontaktniOsoby->get('firma_id')."'");
            if($KartaAdresare->get('firmajeosoba')) {
                $KartaAdresare->set('ob_nazev',$KartaKontaktniOsoby->get('prijmeni')." ".$KartaKontaktniOsoby->get('jmeno'));
                $KartaAdresare->set('ob_ulice',$KartaKontaktniOsoby->get('ulice'));
                $KartaAdresare->set('ob_psc',$KartaKontaktniOsoby->get('psc'));
                $KartaAdresare->set('ob_mesto',$KartaKontaktniOsoby->get('mesto'));
                $KartaAdresare->set('ob_statnazev',$KartaKontaktniOsoby->get('statnazev'));
                $KartaAdresare->set('ob_statzkrat',$KartaKontaktniOsoby->get('statzkrat'));
                if($KartaAdresare->get('provadr_zobch')) {
                    $KartaAdresare->set('pr_nazev',$KartaKontaktniOsoby->get('prijmeni')." ".$KartaKontaktniOsoby->get('jmeno'));
                    $KartaAdresare->set('pr_ulice',$KartaKontaktniOsoby->get('ulice'));
                    $KartaAdresare->set('pr_psc',$KartaKontaktniOsoby->get('psc'));
                    $KartaAdresare->set('pr_mesto',$KartaKontaktniOsoby->get('mesto'));
                    $KartaAdresare->set('pr_statnazev',$KartaKontaktniOsoby->get('statnazev'));
                    $KartaAdresare->set('pr_statzkrat',$KartaKontaktniOsoby->get('statzkrat'));
                    if($KartaAdresare->get('fakadr_zprov')) {
                        $KartaAdresare->set('fa_nazev',$KartaKontaktniOsoby->get('prijmeni')." ".$KartaKontaktniOsoby->get('jmeno'));
                        $KartaAdresare->set('fa_ulice',$KartaKontaktniOsoby->get('ulice'));
                        $KartaAdresare->set('fa_psc',$KartaKontaktniOsoby->get('psc'));
                        $KartaAdresare->set('fa_mesto',$KartaKontaktniOsoby->get('mesto'));
                        $KartaAdresare->set('fa_statnazev',$KartaKontaktniOsoby->get('statnazev'));
                        $KartaAdresare->set('fa_statzkrat',$KartaKontaktniOsoby->get('statzkrat'));
                    };
                };
                $KartaAdresare->update;
            };
        } else {
            if(!$KartaKontaktniOsoby->save(1)) {
                my $Dialog=new Dialog(%MyMoney);
                $Dialog->show("text"=>"Záznam nelze uložit!","type"=>"error");
                return;
            };
        };
        if($Locks) {
            $Locks->remove_lock;
        };
    };
    $MyMoney{'MainCfg'}->window_close("KartaKontaktniOsoby",$MyUI->TOPLEVEL);
    $retcode=$KartaKontaktniOsoby;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};


sub on_email_changed {
    if($MyUI->FORM->{'email'}->get_text) {
        $MyUI->FORM->{'button_email'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'button_email'}->set_sensitive(0);
    };
};


sub on_button_email_clicked {
    my $button=Gnome2::HRef->new ("mailto:".$MyUI->FORM->{'email'}->get_text, "send email");
    $button->clicked;
};


sub stat_clicked {
    my($self,$zkrat,$nazev)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $select_row=$MyUI->FORM->{$zkrat}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('Adresar_last_statzkrat');
    };
    my $Seznam=new Seznam;
    if($Seznam->run('staty',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$select_row])) {
        my $tbl=new Table('g_Staty',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$zkrat}->set_text($tbl->get('kod'));
                $MyUI->FORM->{$nazev}->set_text($tbl->get('popis'));
                $MyMoney{'MainCfg'}->set('Adresar_last_statzkrat',$tbl->get('kod'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$zkrat}->set_text('');
            $MyUI->FORM->{$nazev}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);    
};

sub on_button_stat_clicked {
    $MyUI->stat_clicked('statzkrat','statnazev');
};

sub psc_clicked {
    my($self,$psc,$mesto)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $select_row=$MyUI->FORM->{$psc}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('Adresar_last_psc');
    };
    my $Seznam=new Seznam;
    if($Seznam->run('psc',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$select_row])) {
        my $tbl=new Table('g_Psc',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$psc}->set_text($tbl->get('psc'));
                $MyUI->FORM->{$mesto}->set_text($tbl->get('misto'));
                $MyMoney{'MainCfg'}->set('Adresar_last_psc',$tbl->get('psc'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$psc}->set_text('');
            $MyUI->FORM->{$mesto}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);    
};

sub on_button_psc_clicked {
    $MyUI->psc_clicked('psc','mesto');
};

sub on_osloveni_changed {
    if($MyUI->FORM->{osloveni}->get_history==1) {
        $MyUI->FORM->{pohlavi}->set_history(1);
    };
    if($MyUI->FORM->{osloveni}->get_history>=2) {
        $MyUI->FORM->{pohlavi}->set_history(2);
    };
};

1;
