#!/usr/bin/perl -w

package KartaSkupinyAdresare;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $KartaSkupinyAdresare;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('a_AdrSkup',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    $Locks=0;
    %MyMoney=%params;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('a_AdrSkup',$where,1)) {
        return(0);
    };
    $KartaSkupinyAdresare=new Table('a_AdrSkup',%MyMoney);
    $KartaSkupinyAdresare->load($where);
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdrSkup",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Databaze->Update("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF","skupina_id='".$KartaSkupinyAdresare->get('id')."'","skupina_id"=>0);
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    my $window=$class;
    $MyUI=$class;
    $KartaSkupinyAdresare=new Table('a_AdrSkup',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };
    if($where) {
        if(!$KartaSkupinyAdresare->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $KartaSkupinyAdresare->WriteToUI($window->FORM);
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Karta skupiny adresare');
    $MyMoney{'MainCfg'}->window_open("KartaSkupinyAdresare",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaSkupinyAdresare",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KartaSkupinyAdresare_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaSkupinyAdresare",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $KartaSkupinyAdresare->ReadFromUI($MyUI->FORM);
    if(!$KartaSkupinyAdresare->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemuze byt prazdna!","type"=>"error");
            return;        
    };
    if($MyUI->{'where'}) {
        if(!$KartaSkupinyAdresare->update) {
            return;
        };
    } else {
        if(!$KartaSkupinyAdresare->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaSkupinyAdresare",$MyUI->TOPLEVEL);
    $retcode=$KartaSkupinyAdresare;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

1;
